<?php
/**
* User Menu Button Bar HTML
* @version $Id: toolbar.comprofiler.html.php 344 2006-08-05 10:25:39Z beat $
* @package Community Builder
* @subpackage toolbar.comprofiler.html.php
* @author JoomlaJoe and Beat
* @copyright (C) JoomlaJoe and Beat, www.joomlapolis.com
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/

// ensure this file is being included by a parent file
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

class TOOLBAR_usersextras {
	/**
	* Draws the menu for a New users
	*/
	function _NEW() {
		mosMenuBar::startTable();
		mosMenuBar::save();
		mosMenuBar::cancel('showusers');
		mosMenuBar::spacer();
		mosMenuBar::endTable();
	}
	
	function _EDIT() {
		mosMenuBar::startTable();
		mosMenuBar::save();
		mosMenuBar::cancel('showusers');
		mosMenuBar::spacer();
		mosMenuBar::endTable();
	}

	function _NEW_TAB() {
		mosMenuBar::startTable();
		mosMenuBar::save('saveTab');
		mosMenuBar::cancel('showTab');
		mosMenuBar::spacer();
		mosMenuBar::endTable();
	}
	
	function _EDIT_TAB() {
		mosMenuBar::startTable();
		mosMenuBar::save('saveTab');
		mosMenuBar::cancel('showTab');
		mosMenuBar::spacer();
		mosMenuBar::endTable();
	}
	function _DEFAULT_TAB() {
		mosMenuBar::startTable();
		mosMenuBar::custom( 'newTab', 'new.png', 'new_f2.png', 'New Tab', false );
		mosMenuBar::editList('editTab');
		mosMenuBar::deleteList('The tab will be deleted and cannot be undone!','removeTab');
		mosMenuBar::spacer();
		mosMenuBar::endTable();
	}
	function _NEW_FIELD() {
		mosMenuBar::startTable();
		mosMenuBar::save('saveField');
		mosMenuBar::cancel('showField');
		mosMenuBar::spacer();
		mosMenuBar::endTable();
	}
	
	function _EDIT_FIELD() {
		mosMenuBar::startTable();
		mosMenuBar::save('saveField');
		mosMenuBar::cancel('showField');
		mosMenuBar::spacer();
		mosMenuBar::endTable();
	}
	function _DEFAULT_FIELD() {
		mosMenuBar::startTable();
		mosMenuBar::custom( 'newField', 'new.png', 'new_f2.png', 'New Field', false );
		mosMenuBar::editList('editField');
		mosMenuBar::deleteList('The Field and all user data associated to this field will be lost and cannot be undone!','removeField');
		mosMenuBar::spacer();
		mosMenuBar::endTable();
	}
	function _NEW_LIST() {
		mosMenuBar::startTable();
		mosMenuBar::save('saveList');
		mosMenuBar::cancel('showLists');
		mosMenuBar::spacer();
		mosMenuBar::endTable();
	}
	
	function _EDIT_LIST() {
		mosMenuBar::startTable();
		mosMenuBar::save('saveList');
		mosMenuBar::cancel('showLists');
		mosMenuBar::spacer();
		mosMenuBar::endTable();
	}
	function _DEFAULT_LIST() {
		mosMenuBar::startTable();
		mosMenuBar::custom( 'newList', 'new.png', 'new_f2.png', 'New List', false );
		mosMenuBar::editList('editList');
		mosMenuBar::deleteList('The selected List(s) will be deleted and cannot be undone!','removeList');
		mosMenuBar::spacer();
		mosMenuBar::endTable();
	}
	function _EDIT_CONFIG() {
		mosMenuBar::startTable();
		mosMenuBar::save('saveconfig');
		mosMenuBar::cancel();
		mosMenuBar::spacer();
		mosMenuBar::endTable();
	}

	
	function _DEFAULT() {
		mosMenuBar::startTable();
		mosMenuBar::addNew();
		mosMenuBar::editList();
		mosMenuBar::deleteList();
		mosMenuBar::spacer();
		mosMenuBar::endTable();
	}
		function _EDIT_PLUGIN() {
		global $id;
		
		mosMenuBar::startTable();
		mosMenuBar::save('savePlugin');
		if (is_callable(array("mosMenuBar","apply"))) {		// 	/* Mambo 4.5.0 support: */
			mosMenuBar::spacer();
			mosMenuBar::apply('applyPlugin');
		}
		mosMenuBar::spacer();
		mosMenuBar::cancel( 'cancelPlugin', 'Close' );
		/*
		if ( $id ) {
			// for existing content items the button is renamed `close`
			mosMenuBar::cancel( 'cancelPlugin', 'Close' );
		} else {
			mosMenuBar::cancel('showPlugins');
		}
		*/
		mosMenuBar::endTable();
	}

	function _DEFAULT_PLUGIN() {
		mosMenuBar::startTable();
		mosMenuBar::publishList('publishPlugin');
		mosMenuBar::spacer();
		mosMenuBar::unpublishList('unpublishPlugin');
		// mosMenuBar::spacer();
		// mosMenuBar::   "addInstall" link ('newPlugin');
/*
		mosMenuBar::spacer();
		if (is_callable(array("mosMenuBar","addNewX"))) {		// Mambo 4.5.0 support:
			mosMenuBar::addNewX('newPlugin');
		} else {
			mosMenuBar::addNew('newPlugin');
		}
*/
		mosMenuBar::spacer();
		if (is_callable(array("mosMenuBar","editListX"))) {		// Mambo 4.5.0 support:
			mosMenuBar::editListX('editPlugin');
		} else {
			mosMenuBar::editList('editPlugin');
		}
		mosMenuBar::spacer();
		mosMenuBar::deleteList('','deletePlugin');
		mosMenuBar::spacer();
		mosMenuBar::endTable();
	}
}
?>